/*
 * (C) COPYRIGHT 2009 CRZ
 *
 * File Name : L3G4200DH_crz.c
 * 
 * History 
 *
 * when         who       what, where, why
 *--------------------------------------------------------------
 * 03/13/2012   sikim     Initial release
 */

/* Includes */

#include "hw_config.h"

/*****************************************/
/* Device Enumeration						     */					
/*****************************************/
#define DEVICE_ID		0xD6

#define INTERFACE_I2C	0

/*****************************************/
/* I2C setup									     */					
/*****************************************/
#define SA0_CONNECTED_TO_VCC	(0x02)
#define SA0_CONNECTED_TO_GND	(0)
#define SA0_CONFIG				(SA0_CONNECTED_TO_VCC)
#define SLAVE_ADDRESS			(DEVICE_ID|SA0_CONFIG)

/*****************************************/
/* Register Definition							     */					
/*****************************************/
#define WHO_AM_I		0x0F
#define CTRL_REG1		0x20
#define CTRL_REG2		0x21
#define CTRL_REG3		0x22
#define CTRL_REG4		0x23
#define CTRL_REG5		0x24
#define HP_FILTER_RESET	0x25
#define STATUS_REG		0x27
#define OUT_X_L			0x28
#define OUT_X_H			0x29
#define OUT_Y_L			0x2A
#define OUT_Y_H			0x2B
#define OUT_Z_L			0x2C
#define OUT_Z_H			0x2D
#define INT1_CFG		0x30
#define INT1_SOURCE		0x31
#define INT1_THS		0x32
#define INT1_DURATION	0x33
#define INT2_CFG		0x34
#define INT2_SOURCE		0x35
#define INT2_THS		0x36
#define INT2_DURATION	0x37

typedef enum adc_data
{
	X_VALUE=0,
	Y_VALUE,
	Z_VALUE,

	NUM_OF_VALUE
}ADC_DATA;

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void GYRO_L3G4200_temp(void)
{

}

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void GYRO_L3G4200_id(void)
{
    uint8_t i2c_data[3]; 
    i2c1_addr7_read(SLAVE_ADDRESS, WHO_AM_I, i2c_data, 1);      
    
    Delay(100);
    
    printf("Who Am I=0x%x\r\n \n", i2c_data[0]);        
}

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void GYRO_L3G4200_vInit (void)
{
    uint8_t i2c_data;
    i2c_data = 0x6F;
    i2c1_1byte_addr7_write(SLAVE_ADDRESS, CTRL_REG1, &i2c_data);     
}

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void GYRO_L3G4200_vTest (void)
{

	u8 u8X=0, u8Y=0, u8Z=0;
	signed short n16Value[NUM_OF_VALUE]={0};


	//ROLL 
    i2c1_addr7_read(SLAVE_ADDRESS, OUT_X_H, &u8X, 1);          
	printf ("u8XH=%d\r\n", u8X);

	n16Value[X_VALUE]= u8X<<8;

    i2c1_addr7_read(SLAVE_ADDRESS, OUT_X_L, &u8X, 1);              
	printf ("u8XL=%d\r\n", u8X);

	n16Value[X_VALUE]|= u8X&0xFF;
 
	if (n16Value[X_VALUE]&0x8000==1)
	{
		n16Value[X_VALUE]|=0xF000;
	}

	// PITCH	
    i2c1_addr7_read(SLAVE_ADDRESS, OUT_Y_H, &u8Y, 1);                  
	printf ("u8YH=%d\r\n", u8Y);

	n16Value[Y_VALUE]= u8Y<<8;

    i2c1_addr7_read(SLAVE_ADDRESS, OUT_Y_L, &u8Y, 1);                      
	printf ("u8YL=%d\r\n", u8Y);	
	
	n16Value[Y_VALUE]|= u8Y&0xFF;

	if (n16Value[Y_VALUE]&0x8000==1)
	{
		n16Value[Y_VALUE]|=0xF000;
	}


	// YAW
    i2c1_addr7_read(SLAVE_ADDRESS, OUT_Z_H, &u8Z, 1);                          
	printf ("u8ZH=%d\r\n", u8Z);
	
	n16Value[Z_VALUE]= u8Z<<8;
	
    i2c1_addr7_read(SLAVE_ADDRESS, OUT_Z_L, &u8Z, 1);                              
	printf ("u8ZL=%d\r\n", u8Z);
	
	n16Value[Z_VALUE]|= u8Z&0xFF;
	
	if (n16Value[Z_VALUE]&0x8000==1)
	{
		n16Value[Z_VALUE]|=0xF000;
	}
    
    Delay(100);

	printf ("ADC VALUE=%d, %d, %d\r\n", n16Value[X_VALUE], n16Value[Y_VALUE], n16Value[Z_VALUE]);
}




