/*
 * (C) COPYRIGHT 2009 CRZ
 *
 * File Name : 3-Axis_Acc_Sensor.c
 * 
 * History 
 *
 * when         who       what, where, why
 *--------------------------------------------------------------
 * 09/29/2011   sikim     Initial release
 */

/* Includes */

#include "hw_config.h"

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
#define BMA280_SLAVE_ADDRESS (0x18<<1)//x30
void three_axis_acc_sensor_Initialize (void)
{
    GPIO_InitTypeDef GPIO_InitStructure;  
    I2C_InitTypeDef  I2C_InitStructure;    
    /******************** Clock Enable ********************/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);  
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);
        
    /******************** GPIO configure ********************/
    GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_OD;
    GPIO_Init(GPIOB, &GPIO_InitStructure);          

    /******************** Fuction configure ********************/
    I2C_DeInit(I2C1);
    /* I2C1 Init */
    I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
    I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
    I2C_InitStructure.I2C_OwnAddress1 = BMA280_SLAVE_ADDRESS;
    I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
    I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
    I2C_InitStructure.I2C_ClockSpeed = 400000;
    I2C_Cmd(I2C1, ENABLE);    
    I2C_Init(I2C1, &I2C_InitStructure);
}

/*
 * Description : test function.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void three_axis_acc_sensor_test2 (void)
{
    uint8_t byTemp[9] = {0,};
    
    i2c1_addr7_read(BMA280_SLAVE_ADDRESS, 0x00,byTemp,  1);
    printf("byTemp [ %x ]\n", byTemp[0]);
    printf("byTemp [ %x ]\n", byTemp[1]);            
    printf("byTemp [ %x ]\n", byTemp[2]);            
    printf("byTemp [ %x ]\n", byTemp[3]);            
    printf("byTemp [ %x ]\n", byTemp[4]);            
    printf("byTemp [ %x ]\n", byTemp[5]);            
    printf("byTemp [ %x ]\n", byTemp[6]);            
    printf("byTemp [ %x ]\n", byTemp[7]);            
    printf("byTemp [ %x ]\n", byTemp[8]);                            
}

/*
 * Description : test function.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void three_axis_acc_sensor_test (void)
{
    uint8_t I2C_Value;

    /* Check Busy */
     printf("Check Busy  three_axis_acc_sensor_test\n");
    while (I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY));
    
    //----------- 1 Byte Write ------------------------------------
    
    /* Send START condition */
    I2C_GenerateSTART(I2C1, ENABLE);    
    
    /* Test on EV5 and clear it */
    printf("1  three_axis_acc_sensor_test\n");
    while (!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
    
    /* Send slave address for write */
    I2C_Send7bitAddress(I2C1, BMA280_SLAVE_ADDRESS, I2C_Direction_Transmitter);
    
    /* Test on EV6 and clear it */
    printf("2  three_axis_acc_sensor_test\n");
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
    
    /* Send the BMA150 internal address to write to : only one byte Address */
    I2C_SendData(I2C1, 0x00);           // chip id
//    I2C_SendData(I2C1, 0x01);         // version
//    I2C_SendData(I2C1, 0x02);         // acc x [1:0]
//    I2C_SendData(I2C1, 0x03);         // acc x [9:2]
//    I2C_SendData(I2C1, 0x04);         // acc y [1:0]
//    I2C_SendData(I2C1, 0x05);         // acc y [9:2]
//    I2C_SendData(I2C1, 0x06);         // acc z [1:0]
//    I2C_SendData(I2C1, 0x07);         // acc z [9:2]
//    I2C_SendData(I2C1, 0x08);         // temp
    
    /* Test on EV8 and clear it */
    printf("3  three_axis_acc_sensor_test\n");
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));    
    
    /* Send STOP condition */
    I2C_GenerateSTOP(I2C1, ENABLE);
    
    //----------- 1 Byte Read ------------------------------------

    /* Send START condition */
    I2C_GenerateSTART(I2C1, ENABLE);    
    /* Test on EV5 and clear it */
    /* Check SR1->SB, SR1->ADDR, SR2->MSL */
    printf("4  three_axis_acc_sensor_test\n");
    while (!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
    /* Send slave address for write */
    I2C_Send7bitAddress(I2C1, BMA280_SLAVE_ADDRESS, I2C_Direction_Receiver);
    printf("5  three_axis_acc_sensor_test\n");
    /* Test on EV6 and clear it */
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));

    /* Clear ACK */
    I2C_AcknowledgeConfig(I2C1, DISABLE);    

    /* Send STOP Condition */
    I2C_GenerateSTOP(I2C1, ENABLE);    
    printf(" 6 three_axis_acc_sensor_test\n");
    while ((I2C_GetLastEvent(I2C1) & 0x0040) != 0x000040); /* Poll on RxNE */    

    /* Read the data */
    I2C_Value = I2C_ReceiveData(I2C1);    
    printf("I2C_Value = [0x%x]\n", I2C_Value);
    
    /* Enable Acknowledgement to be ready for another reception */
    I2C_AcknowledgeConfig(I2C1, ENABLE);    
}

/*
 * Description : none.
 * Argument(s) : none.
 * Return(s)   : none.
 * Note(s)     : none.
 */
void three_axis_acc_sensor_read_id (void)
{
    uint8_t I2C_Value;

    /* Check Busy */
    while (I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY));
    
    //----------- 1 Byte Write ------------------------------------
    
    /* Send START condition */
    I2C_GenerateSTART(I2C1, ENABLE);    
    
    /* Test on EV5 and clear it */
    while (!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
    
    /* Send slave address for write */
    I2C_Send7bitAddress(I2C1, BMA280_SLAVE_ADDRESS, I2C_Direction_Transmitter);
    
    /* Test on EV6 and clear it */
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
    
    /* Send the BMA150 internal address to write to : only one byte Address */
    I2C_SendData(I2C1, 0x00);           // chip id
    
    /* Test on EV8 and clear it */
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));    
    
    /* Send STOP condition */
    I2C_GenerateSTOP(I2C1, ENABLE);
    
    //----------- 1 Byte Read ------------------------------------

    /* Send START condition */
    I2C_GenerateSTART(I2C1, ENABLE);    
    /* Test on EV5 and clear it */
    /* Check SR1->SB, SR1->ADDR, SR2->MSL */
    while (!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
    /* Send slave address for write */
    I2C_Send7bitAddress(I2C1, BMA280_SLAVE_ADDRESS, I2C_Direction_Receiver);
    
    /* Test on EV6 and clear it */
    while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));

    /* Clear ACK */
    I2C_AcknowledgeConfig(I2C1, DISABLE);    

    /* Send STOP Condition */
    I2C_GenerateSTOP(I2C1, ENABLE);    

    while ((I2C_GetLastEvent(I2C1) & 0x0040) != 0x000040); /* Poll on RxNE */    

    /* Read the data */
    I2C_Value = I2C_ReceiveData(I2C1);    
    printf("I2C_Value = [ 0x%x ]\n", I2C_Value);
    
    /* Enable Acknowledgement to be ready for another reception */
    I2C_AcknowledgeConfig(I2C1, ENABLE);    
}

